const appConfig = require('./src/app.config')
const BundleAnalyzerPlugin = require('webpack-bundle-analyzer').BundleAnalyzerPlugin
const webpack = require('webpack')

/** @type import('@vue/cli-service').ProjectOptions */
module.exports = {
  configureWebpack: {
    // remove webpack plugins for now
    // plugins: [
    //   new BundleAnalyzerPlugin(),
    //   new webpack.IgnorePlugin({
    //     checkResource (resource, context) {
    //       if (context.includes('bootstrap-vue')) {
    //         console.log(resource, ':::', context)
    //         console.log(arguments)
    //       }
    //       return false
    //     },
    //   }),
    //   new webpack.IgnorePlugin({
    //     //  /^\.\/icons/
    //     resourceRegExp: /^\.\/icons$/,
    //     contextRegExp: /bootstrap-vue$/,
    //     // resourceRegExp: /^icons(.*)$/,
    //     // contextRegExp: /^bootstrap-vue(.*)$/
    //   })
    // ],
    // We provide the app's title in Webpack's name field, so that
    // it can be accessed in index.html to inject the correct title.
    name: appConfig.title,
    resolve: {
      alias: require('./aliases.config').webpack
    },
    performance: {
      // Only enable performance hints for production builds,
      // outside of tests.
      hints:
        process.env.NODE_ENV === 'production' &&
        !process.env.VUE_APP_TEST &&
        'warning'
    }
  },
  lintOnSave: false,
  css: {
    sourceMap: false
    // TODO 2020 https://stackoverflow.com/questions/35580710/using-sass-variables-in-a-vuejs-component
    // loaderOptions: {
    //   sass: {
    //     additionalData:
    //     @import "@src/design/_variables.scss";
    //     `
    //   }
    // }
  },

  // https://cli.vuejs.org/guide/cli-service.html
  devServer: {
    watchOptions: {
      hot: true,
      liveReload: true,
      poll: false
    },
      proxy: { '/api': { target: process.env.API_BASE_URL } }
    // ...(process.env.API_BASE_URL
    //   ? // Proxy API endpoints to the production base URL.
    //     { proxy: { '/api': { target: process.env.API_BASE_URL } } }
    //   : // Proxy API endpoints a local mock API.
    //     { before: require('./tests/mock-api') })
  }
}
